/*
 * 28.08.2004
 * by Andreas Grunewald
 */
package org.jd3lib;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;

/**
 * @author Andreas Grunewald
 * 
 * LATER 1.0 Write Documentation
 */
public class FieldTerminatedString
        extends Id3Field {

    String data;

    public static String readUntilZero(ByteArrayInputStream inStream) {
        ByteArrayOutputStream tempStream;
        int tempHold;
        tempStream = new ByteArrayOutputStream();
        tempHold = 0;
        while (inStream.available() > 0) {
            tempHold = inStream.read();
            if (tempHold != 0x00)
                tempStream.write(tempHold);
            else
                break;
        }
        return tempStream.toString();
    }

    /**
     * @param string
     */
    public FieldTerminatedString(String string) {
        data = string;
    }

    /**
     *  
     */
    public FieldTerminatedString() {
        data = "";
    }

    /*
     * (non-Javadoc)
     * 
     * @see de.gruni.thejee.Id3Field#getBytes()
     */
    public byte[] getBytes() {
        ByteArrayOutputStream buff = new ByteArrayOutputStream();
        try {
            buff.write(data.getBytes());
            buff.write(0x00);
        } catch (IOException e) {
            e.printStackTrace();
        }
        return buff.toByteArray();
    }

    /**
     * @param string
     */
    public void setField(String string) {
        data = string;
    }

    public String getString() {
        return data;
    }

    public String toString() {
        return data;
    }

    /*
     * (non-Javadoc)
     * 
     * @see de.gruni.thejee.Id3Field#getValue()
     */
    public Object getValue() {
        return data;
    }
}