/*
 * $Id: Id3FrameGEOB.java,v 1.7 2005/04/27 08:38:29 gruni Exp $
 * $Author: gruni $ 
 * 
 * $Log: Id3FrameGEOB.java,v $
 * Revision 1.7  2005/04/27 08:38:29  gruni
 * changes due to refactoring
 *
 */
package org.jd3lib;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.nio.ByteBuffer;

/**
 * 4.16. General encapsulated object
 * 
 * In this frame any type of file can be encapsulated. After the header, 'Frame
 * size' and 'Encoding' follows 'MIME type' [MIME] represented as as a
 * terminated string encoded with ISO 8859-1 [ISO-8859-1]. The filename is case
 * sensitive and is encoded as 'Encoding'. Then follows a content description as
 * terminated string, encoded as 'Encoding'. The last thing in the frame is the
 * actual object. The first two strings may be omitted, leaving only their
 * terminations. MIME type is always an ISO-8859-1 text string. There may be
 * more than one "GEOB" frame in each tag, but only one with the same content
 * descriptor.
 * 
 * <Header for 'General encapsulated object', ID: "GEOB">
 * 
 * Text encoding $xx
 * 
 * MIME type <text string> $00
 * 
 * Filename <text string according to encoding> $00 (00)
 * 
 * Content description <text string according to encoding> $00 (00)
 * 
 * Encapsulated object <binary data>
 * 
 * @author Andreas Grunewald
 *  
 */
public class Id3FrameGEOB
    extends Id3FrameMultiple {

  /**
   * @param frameData
   * @param header
   */
  public Id3FrameGEOB(ByteBuffer frameData, Id3v2FrameHeader header) {
    super(frameData, header);
    // LATER 0.7 Auto-generated constructor stub
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#initialize(java.io.InputStream,
   *      org.jd3lib.Id3v2FrameHeader)
   */
  protected void initializeExisting(InputStream tagData,
      Id3v2FrameHeader header2) {
    //System.out.println("RunningGEOB initialize");
    byte[] temp = new byte[header2.getSize()];
    try {
      tagData.read(temp);
    } catch (IOException e) {
      //LATER 1.5 Auto-generated catch block
      e.printStackTrace();
    }
    //TODO Load data from Temp Array into fields
    //data = new FrameData(temp);

  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#getDataString()
   */
  protected String getFrameString() {
    // LATER 0.1 Auto generated method stub
    return null;
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#initializeNew(org.jd3lib.Id3v2FrameHeader)
   */
  protected void initializeNew(Id3v2FrameHeader header) {
    // LATER 0.1 Auto generated method stub

  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#getFrameData()
   */
  protected ByteArrayOutputStream getFrameData() {
    // LATER 0.1 Auto generated method stub
    return new ByteArrayOutputStream();
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3FrameMultiple#isDifferent(org.jd3lib.Id3FrameMultiple)
   */
  public boolean isDifferent(Id3FrameMultiple toCompare) {
    // LATER 0.1 Auto generated method stub
    return false;
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#initializeExisting(java.nio.ByteBuffer,
   *      org.jd3lib.Id3v2FrameHeader)
   */
  protected void initializeExisting(ByteBuffer frameData,
      Id3v2FrameHeader header) {
    System.out.println("RunningGEOB initialize");
    //DONEXT implement reading of GEOB

  }

}