/*
 * $Id: Id3FramePRIV.java,v 1.8 2005/04/27 08:41:38 gruni Exp $
 * $Author: gruni $ 
 * 
 * $Log: Id3FramePRIV.java,v $
 * Revision 1.8  2005/04/27 08:41:38  gruni
 * changes due to refactoring
 *
 */
package org.jd3lib;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.nio.ByteBuffer;

import org.jd3lib.util.DebugOut;

/**
 * 4.28. Private frame
 * 
 * This frame is used to contain information from a software producer that its
 * program uses and does not fit into the other frames. The frame consists of an
 * 'Owner identifier' string and the binary data. The 'Owner identifier' is a
 * null-terminated string with a URL [URL] containing an email address, or a
 * link to a location where an email address can be found, that belongs to the
 * organisation responsible for the frame. Questions regarding the frame should
 * be sent to the indicated email address. The tag may contain more than one
 * "PRIV" frame but only with different contents. It is recommended to keep the
 * number of "PRIV" frames as low as possible.
 * 
 * <Header for 'Private frame', ID: "PRIV">
 * 
 * Owner identifier <text string> $00
 * 
 * The private data <binary data>
 * 
 * @author Andreas Grunewald
 *  
 */
public class Id3FramePRIV
    extends Id3FrameMultiple {

  /**
   * @param frameData
   * @param header
   */
  public Id3FramePRIV(ByteBuffer frameData, Id3v2FrameHeader header) {
    super(frameData, header);
    // LATER 0.7 Auto-generated constructor stub
  }

  private FieldTerminatedString OwnerIdentifier;

  private byte[] ThePrivateData;

  /*
   * (non-Javadoc)
   * 
   * @see de.gruni.thejee.Id3Frame#initialize(java.io.InputStream,
   *      de.gruni.thejee.Id3v2FrameHeader)
   */
  protected void initializeExisting(InputStream tagData,
      Id3v2FrameHeader header2) {
    DebugOut.println("RunningPRIV initialize");
    byte[] temp = new byte[header2.getSize()];
    try {
      tagData.read(temp);
    } catch (IOException e) {
      //LATER 1.5 Auto-generated catch block
      e.printStackTrace();
    }
    //TODO Load data from Temp Array into fields
    //data = new FrameData(temp);

  }

  /*
   * (non-Javadoc)
   * 
   * @see de.gruni.thejee.Id3Frame#getDataString()
   */
  protected String getFrameString() {
    // LATER 0.1 Auto generated method stub
    return null;
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#initializeNew(org.jd3lib.Id3v2FrameHeader)
   */
  protected void initializeNew(Id3v2FrameHeader header) {
    // LATER 0.1 Auto generated method stub

  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#getFrameData()
   */
  protected ByteArrayOutputStream getFrameData() {
    // LATER 0.1 Auto generated method stub
    return null;
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3FrameMultiple#isDifferent(org.jd3lib.Id3FrameMultiple)
   */
  public boolean isDifferent(Id3FrameMultiple toCompare) {
    // LATER 0.1 Auto generated method stub
    return false;
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#initializeExisting(java.nio.ByteBuffer,
   *      org.jd3lib.Id3v2FrameHeader)
   */
  protected void initializeExisting(ByteBuffer frameData,
      Id3v2FrameHeader header) {
    // LATER 0.1 Auto generated method stub

  }

}