/*
 * 29.08.2004
 * by Andreas Grunewald
 */
package org.jd3lib;

import java.nio.ByteBuffer;

/**
 * TCON The 'Content type', which previously was stored as a one byte numeric
 * value only, is now a numeric string. You may use one or several of the types
 * as ID3v1.1 did or, since the category list would be impossible to maintain
 * with accurate and up to date categories, define your own.
 * 
 * References to the ID3v1 genres can be made by, as first byte, enter "("
 * followed by a number from the genres list (appendix A.) and ended with a ")"
 * character. This is optionally followed by a refinement, e.g. "(21)" or
 * "(4)Eurodisco". Several references can be made in the same frame, e.g.
 * "(51)(39)". If the refinement should begin with a "(" character it should be
 * replaced with "((", e.g. "((I can figure out any genre)" or "(55)((I
 * think...)". The following new content types is defined in ID3v2 and is
 * implemented in the same way as the numerig content types, e.g. "(RX)".
 * 
 * RX Remix CR Cover
 * 
 * @author Andreas Grunewald
 * 
 * LATER 1.0 Write Documentation
 */
public class Id3FrameTCON
    extends Id3FrameTBase {

  /**
   * @param frameData
   * @param header
   */
  public Id3FrameTCON(ByteBuffer frameData, Id3v2FrameHeader header) {
    super(frameData, header);
    //LATER 0.7 Auto-generated constructor stub
  }

}