/*
 * $Id: Id3FramesBinaryTest.java,v 1.3 2005/04/27 08:42:11 gruni Exp $
 * $Author: gruni $ 
 * 
 * $Log: Id3FramesBinaryTest.java,v $
 * Revision 1.3  2005/04/27 08:42:11  gruni
 * changes due to refactoring
 *
 */
package org.jd3lib;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.Constructor;

import junit.framework.TestCase;

/**
 * @author Andreas Grunewald
 * 
 * LATER 1.0 Write Documentation
 */
public class Id3FramesBinaryTest
    extends TestCase {

  /**
   * @param theId3Frame
   */
  private void assertFrame(Id3Frame theId3Frame) {
    String theFrame = theId3Frame.getFrameID();
    byte[] shouldByte = null;
    try {
      FileInputStream shouldStream = new FileInputStream(
          "test_data/tagTestCases/test" + theFrame + ".id3frame");
      shouldByte = new byte[shouldStream.available()];
      shouldStream.read(shouldByte);
    } catch (FileNotFoundException e) {
      e.printStackTrace();
    } catch (IOException e) {
      e.printStackTrace();
    }
    byte[] isByte = theId3Frame.getAllData().toByteArray();
    assertEquals("Length", shouldByte.length, isByte.length);
    String isString = "";
    String shouldString = "";
    for (int i = 0; i < shouldByte.length; i++) {
      isString += isByte[i] + "\n";
      shouldString += shouldByte[i] + "\n";
      if (theFrame.equals("TENC"))
          System.out.println(shouldByte[i] + "=" + isByte[i]);
      //assertEquals(shouldByte[i], isByte[i]);
    }
    assertEquals(shouldString, isString);

  }

  private Id3FrameTBase getTbase(String frameID) {
    Id3FrameTBase newFrame = null;
    try {
      Class team = Class.forName(Id3Frame.class.getName() + frameID);
      Class[] argClass = { InputStream.class, Id3v2FrameHeader.class };
      Object[] args = { null, new Id3v2FrameHeader(frameID) };
      Constructor constT = team.getConstructor(argClass);
      newFrame = (Id3FrameTBase) constT.newInstance(args);
    } catch (Exception e) {
      e.printStackTrace();
    }
    if (newFrame != null) {
      newFrame.setTextEncoding(new FieldEncoding(FieldEncoding.ISO88591));
      newFrame.setInformation("junit test");
    }
    return newFrame;
  }

  public void testCOMM() {
    Id3FrameCOMM theCOMM = new Id3FrameCOMM(null, new Id3v2FrameHeader("COMM"));
    theCOMM.setComment("junit test");
    assertFrame(theCOMM);
  }

  public void testTALB() {
    assertFrame(getTbase("TALB"));
  }

  public void testTCOM() {
    assertFrame(getTbase("TCOM"));
  }

  public void testTCON() {
    assertFrame(getTbase("TCON"));
  }

  public void testTCOP() {
    assertFrame(getTbase("TCOP"));
  }

  public void testTENC() {
    assertFrame(getTbase("TENC"));
  }

  public void testTIT2() {
    assertFrame(getTbase("TIT2"));
  }

  public void testTOPE() {
    assertFrame(getTbase("TOPE"));
  }

  public void testTPE1() {
    assertFrame(getTbase("TRCK"));
  }

  public void testTYER() {
    assertFrame(getTbase("TYER"));
  }

  public void testWXXX() {
    Id3FrameWXXX theFrame = new Id3FrameWXXX(null, new Id3v2FrameHeader("WXXX"));
    theFrame.setURL("junit test");
    assertFrame(theFrame);
  }
}