/*
 * $Id: Id3v2Tag_Getter.java,v 1.1 2005/04/27 09:01:26 gruni Exp $
 * $Author: gruni $ 
 * $Revision: 1.1 $
 * $Date: 2005/04/27 09:01:26 $
 * $Log: Id3v2Tag_Getter.java,v $
 * Revision 1.1  2005/04/27 09:01:26  gruni
 * retrieves the ID3v2Tag factory
 *
 */
package org.jd3lib;

import org.jd3lib.util.Coder;

/**
 * @author Grunewald
 */
public class Id3v2Tag_Getter {

  private Id3v2Tag_Getter() {
    //Hide constructor
  }

  /**
   * @param bs
   * @return
   */
  public static Id3v2TagFactory getFactory(byte[] headerData) {
    //  ID3Header lesen
    //Detect if ID3v2 Header
    String Test = "" + (char) headerData[0] + (char) headerData[1]
        + (char) headerData[2];
    if ("ID3".equals(Test)) {
      //    Detect Version Number
      byte versionMajor = headerData[3];
      byte versionMinor = headerData[4];
      byte flags = headerData[5];
      // Integer.toBinaryString());

      byte[] sizeArray = { headerData[6], headerData[7], headerData[8],
          headerData[9] };
      int size = Coder.getSyncsafeIntegerValue(sizeArray);
      switch (versionMajor) {
        case 3:
          return new Id3v2_3TagFactory(versionMinor, flags, size);
        default:
          return null;
      }

    }
    return null;

  }

}