/*
 * $Id: Id3v2_3FrameHeader.java,v 1.1 2005/04/27 08:54:30 gruni Exp $
 * $Author: gruni $ 
 *
 * $Log: Id3v2_3FrameHeader.java,v $
 * Revision 1.1  2005/04/27 08:54:30  gruni
 * new Frame header for ID3v2.3 Tags
 *
 */
package org.jd3lib;

import java.nio.ByteBuffer;

import org.jd3lib.util.Coder;

/**
 * @author Grunewald
 */
public class Id3v2_3FrameHeader
    extends Id3v2FrameHeader {

  private byte[] Flags = new byte[2];

  /**
   * @param headbuf
   */
  public Id3v2_3FrameHeader(byte[] headbuf) {
    if (headbuf[0] == 0) {
      readoutPadding(ByteBuffer.wrap(headbuf));
    } else {
      setFrameID("" + (char) headbuf[0] + (char) headbuf[1] + (char) headbuf[2]
          + (char) headbuf[3]);
      byte[] temp = { headbuf[4], headbuf[5], headbuf[6], headbuf[7] };

      setSize(calculateSize(temp));

      Flags[0] = headbuf[8];
      Flags[1] = headbuf[9];
    }
  }

  /**
   * //if ID3v2.3 the Framesize is not syncsafe
   * 
   * @return
   */
  protected int calculateSize(byte[] temp) {
    return Coder.getIntegerValue(temp);
  }

  public String toString() {
    return super.toString() + "Flags    " + Integer.toBinaryString(Flags[0])
        + " " + Integer.toBinaryString(Flags[1]) + "\n";
  }
}