/*
 * $Id: WampID3v2Test.java,v 1.2 2005/01/27 17:27:15 gruni Exp $
 * $Author: gruni $ 
 * $Revision: 1.2 $
 * $Date: 2005/01/27 17:27:15 $
 * $Log: WampID3v2Test.java,v $
 * Revision 1.2  2005/01/27 17:27:15  gruni
 * updated
 *
 * Revision 1.8  2004/12/16 16:59:52  gruni
 * a lot of updates switching to NIO and adding ID3v1
 */
package org.jd3lib.adapter;

import junit.framework.TestCase;

/**
 * @author Andreas Grunewald
 */
public class WampID3v2Test extends TestCase {

    private static final int testIntValue = 0;

    // private static final String titleValue = "WINAMP Title";

    private static final String testStringValue = "WINAMP Teststring";

    Wamp amp;

    private int trackValue = 7;

    /*
     * (non-Javadoc)
     * 
     * @see junit.framework.TestCase#setUp()
     */
    protected void setUp() throws Exception {
        /*FIXME 0.4 Create non Tagged file for this testcase
         * so that amp= new Wamp(new Mp3File(testfile.mp3));
          amp = new Wamp();*/
        super.setUp();
    }

    public void testEnableID3v2Tag() {
        amp.enableID3v2Tag();
        assertNotNull(amp.v2);
        amp.disableID3v2Tag();
        amp.update();
        assertNull(amp.v2);
    }

    public void testV2Album() {
        amp.enableID3v2Tag();
        amp.v2.setAlbum(testStringValue);
        assertEquals(testStringValue, amp.v2.getAlbum());
    }

    public void testV2Artist() {
        amp.enableID3v2Tag();
        amp.v2.setArtist(testStringValue);
        assertEquals(testStringValue, amp.v2.getArtist());
    }

    public void testV2Comment() {
        amp.enableID3v2Tag();
        amp.v2.setComment(testStringValue);
        assertEquals(testStringValue, amp.v2.getComment());
    }

    public void testV2Composer() {
        amp.enableID3v2Tag();
        amp.v2.setComposer(testStringValue);
        assertEquals(testStringValue, amp.v2.getComposer());
    }

    public void testV2Copyright() {
        amp.enableID3v2Tag();
        amp.v2.setCopyright(testStringValue);
        assertEquals(testStringValue, amp.v2.getCopyright());
    }

    public void testV2EncodedBy() {
        amp.enableID3v2Tag();
        amp.v2.setEncodedBy(testStringValue);
        assertEquals(testStringValue, amp.v2.getEncodedBy());
    }

    public void testV2Genre() {
        amp.enableID3v2Tag();
        amp.v2.setGenre(testStringValue);
        assertEquals(testStringValue, amp.v2.getGenre());
    }

    public void testV2OrigArtist() {
        amp.enableID3v2Tag();
        amp.v2.setOrigArtist(testStringValue);
        assertEquals(testStringValue, amp.v2.getOrigArtist());
    }

    public void testV2Title() {
        amp.enableID3v2Tag();
        amp.v2.setTitle(testStringValue);
        assertEquals(testStringValue, amp.v2.getTitle());
    }

    public void testV2Track() {
        amp.enableID3v2Tag();
        amp.v2.setTrack(trackValue);
        assertEquals(trackValue, amp.v2.getTrack());
    }

    public void testV2URL() {
        amp.enableID3v2Tag();
        amp.v2.setURL(testStringValue);
        assertEquals(testStringValue, amp.v2.getURL());
    }

    public void testV2Year() {
        amp.enableID3v2Tag();
        amp.v2.setYear(testIntValue);
        assertEquals(testIntValue, amp.v2.getYear());
    }

}