/*
 * $Id: ArcLibUtils.java,v 1.1 2005/04/27 07:56:22 gruni Exp $
 * $Author: gruni $ 
 * $Revision: 1.1 $
 * $Date: 2005/04/27 07:56:22 $
 * $Log: ArcLibUtils.java,v $
 * Revision 1.1  2005/04/27 07:56:22  gruni
 * new Utility class for detecting the Gmini
 *
 */
package org.jd3lib.archoslib;

import java.io.File;

import org.jd3lib.AudioFile;
import org.jd3lib.MP3File;

/**
 * @author Grunewald
 */
public class ArcLibUtils {

  /**
   * Returns the number of the root in which the Gmini can be found.
   * */
  public static int detectGmini(File[] rts) {         
      int out = -1;
      for (int i = 0; i < rts.length; i++) {
        String path = rts[i].getPath();
        File jrb = new File(path + "System\\JBR2.BIN");
        File pk = new File(path + "System\\ProductKey.txt");
        if (jrb.isFile() && pk.isFile()) {
  //        System.out.println("Assuming I found Gmini at "
  //            + rts[i].getPath());
          out = i;
          break;
        }
      }
      return out;
    }
  
  public static AudioFile getDecodedFile(File input){
    
    // Original working Code
    if (input.getName().toLowerCase().endsWith(".mp3")) return new MP3File(input);
    else if(input.getName().toLowerCase().endsWith(".wma")) return new WMAFile(input);
    else return null;
    
    
  }

}
