/*
 * $Id: DirectoryTraverser.java,v 1.2 2005/04/27 08:09:43 gruni Exp $
 * $Author: gruni $ 
 * $Revision: 1.2 $
 * $Date: 2005/04/27 08:09:43 $
 * $Log: DirectoryTraverser.java,v $
 * Revision 1.2  2005/04/27 08:09:43  gruni
 * -new logging framework used
 * -gcj compatible fireStateChanged method
 * -cancel method
 *
 * Revision 1.1  2005/04/04 15:19:04  gruni
 * runs through directories
 *
 */
package org.jd3lib.archoslib;

import java.io.File;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.EventListenerList;

import org.jd3lib.compatible.Logger;
import org.jd3lib.compatible.Queue;
import org.jd3lib.util.AudioFileFilter;

/**
 * @author Grunewald
 */
public class DirectoryTraverser {
  
  private File root;
  
  EventListenerList listenerList = new EventListenerList();
  
  private ChangeEvent changeEvent;
  
  private int foundFiles;
  
  private boolean cancel;
  
  public DirectoryTraverser() {
    //Nothing to do  
  }
  
  /**
   * @deprecated
   * */
  public DirectoryTraverser(File rootIn) {
    root = rootIn;
    //run();
  }
  
  public Queue[] traverse(File rootIn) {
    // System.out.println(root.getAbsolutePath());
    root = rootIn;
    Queue queue4Dir2bProcessed = new Queue();
    Queue foundAudioFiles = new Queue();
    Queue foundDirectories = new Queue();
    Queue[] out = { foundAudioFiles, foundDirectories };
    if (root.isDirectory()) {
      cancel = false;
      //TODO v2.0 According to JavaDoc Queue.offer is prefered over
      // Queue.add
      queue4Dir2bProcessed.add(root);
      File currentDir;
      while (!(queue4Dir2bProcessed.isEmpty()) && !(cancel)) {
        
        currentDir = (File) queue4Dir2bProcessed.remove();
        if (currentDir.isDirectory()) {
          foundDirectories.add(currentDir.getName());
          //theLib.strings.put(currentDir.getName());
          File[] fileInCurrentDir = currentDir.listFiles(new AudioFileFilter(
              true, true, true));
          if (fileInCurrentDir != null) {//Takes care of not accessible Dirs
            for (int i = 0; i < fileInCurrentDir.length; i++) {
              if (fileInCurrentDir[i].isFile()) {
                //TODO v1.0 add to logging
                Logger.global.info("Contains File:" + fileInCurrentDir[i]);
                foundAudioFiles.add(fileInCurrentDir[i]);
                setFoudFiles(foundAudioFiles.size());
                //TODO v.0.3 notify gui progBar.setString(foundAudioFiles.size()     + " files found");
              } else { //fileInCurrentDir[i].isDirectory()
                //TODO v1.0 add to logging
                // System.out.println("Contains Directory:" +
                // fileArray[i]);
                queue4Dir2bProcessed.add(fileInCurrentDir[i]);
              }
            }
          }
        } else
          /*
           * It should never be possible that temp is not a directory but we want
           * to make sure.
           */
          throw new RuntimeException(
              "ERROR Library117: This condition"
              + " should not be possible, please try to reproduce this error if"
              + "you can please report it as a bug at the projects website.");
      }
      //Second step Iterating over the MP3s
      System.gc();
      return out;
      
    }
    //TODO v1.0 Throw Exception if input is no Directory.
    System.err.println("ERROR root must be Directory");
    return null;
  }
  
  /**
   * @param i
   */
  private void setFoudFiles(int i) {
    foundFiles = i;
    fireStateChanged();
  }
  
  public int getFoundFiles() {
    return foundFiles;
  }
  
  //Notify all listeners that have registered interest for
  // notification on this event type.  The event instance 
  // is lazily created using the parameters passed into 
  // the fire method.
  
  protected void fireStateChanged() {
    // Guaranteed to return a non-null array
    Object[] listeners = listenerList.getListenerList();
    // Process the listeners last to first, notifying
    // those that are interested in this event
    /* TODO Reimplement original Code when GCJ updated
     * Original Code from the API had to be modified because of the GCJ
     for (int i = listeners.length-2; i>=0; i-=2) {
     Logger.global.info("Inside for loop for Statechange");
     if (listeners[i]==ChangeListener.class) {
     // Lazily create the event:
      if (changeEvent == null)
      changeEvent = new ChangeEvent(this);
      Logger.global.info("FIRE STATECHANGE");
      ((ChangeListener)listeners[i+1]).stateChanged(changeEvent);
      
      }
      }*/
    for (int i = listeners.length - 1; i >= 0; i--) {
      if (listeners[i] instanceof ChangeListener) {
        // Lazily create the event:
        if (changeEvent == null) changeEvent = new ChangeEvent(this);
        ((ChangeListener) listeners[i]).stateChanged(changeEvent);
        
      }
    }
  }
  
  public void addChangeListener(ChangeListener l) {
    listenerList.add(ChangeListener.class, l);
  }
  
  public void removeChangeListener(ChangeListener l) {
    listenerList.remove(ChangeListener.class, l);
  }
  
  /**
   * 
   */
  public void cancel() {
    cancel = true;
  }
  
}