/*
 * $Id: Strings.java,v 1.8 2005/04/27 08:23:42 gruni Exp $
 * $Author: gruni $ 
 *
 * $Log: Strings.java,v $
 * Revision 1.8  2005/04/27 08:23:42  gruni
 * structural modifications
 *
 * Revision 1.7  2005/03/02 08:10:49  gruni
 * a lot of structural refactoring
 *
 * Revision 1.6  2005/02/27 01:42:57  gruni
 * changed for new Structure of taking single files and working with them
 *
 * Revision 1.5  2005/01/27 17:27:57  gruni
 * test updated
 *
 * Revision 1.8  2004/12/16 16:59:52  gruni
 * a lot of updates switching to NIO and adding ID3v1
 */
package org.jd3lib.archoslib;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

import org.jd3lib.MetaData;

/**
 * @author Grunewald
 
 */
public class Strings
extends Section implements ArcFileProcessor {
  
  private Hashtable dataBase;
  
  //TODO chek implementation of Paths and PathT for better design of this
  //LATER 1.0 join dataB2 and offsets in one Vector which has StringT objects in it.
  private Vector dataB2;
  
  private Vector offsets;
  
  protected static final String ARTISTS = "ARTISTS";
  
  protected static final String ALBUMS = "ALBUMS";
  
  protected static final String SONGS = "SONGS";
  
  protected static final String ROOT = "ROOT";
  
  private static final String[] standardStrings = { ROOT, ALBUMS, ARTISTS,
      SONGS, "GENRE", "PLAYLISTS" };
  
  /**
   *  
   */
  public Strings() {
    super();
    lazyInit();
    put(standardStrings);
  }
  
  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.archoslib.Section#toByteBuffer()
   */
  protected ByteBuffer toByteBuffer() {
    ByteArrayOutputStream outStream = new ByteArrayOutputStream();
    Iterator dIte = dataB2.iterator();
    try {
      while (dIte.hasNext()) {
        outStream.write(((String) (dIte.next())).getBytes());
        outStream.write(0x00);
      }
    } catch (IOException e) {
      //Should not happen becuase the stream is created and the Iterator
      // exists
      e.printStackTrace();
    }
    return ByteBuffer.wrap(outStream.toByteArray());
  }
  
  public Vector toVector() {
    return dataB2;
  }
  
  public String get(int pos) {
    return (String) dataB2.get(pos);
  }
  
  public int get(String lookup) {
    //TODO Clean up this method
    int out = 0;
    try {
      out = ((Integer) offsets.get(((Integer) dataBase.get(lookup)).intValue()))
      .intValue();
    } catch (NullPointerException e) {
      System.err.println("Wanted to lookup String \"" + lookup + "\" but it"
          + " seems that it is not in the database");
      
      //e.printStackTrace();
      
    }
    //int out = end;
    /*
     * for (int i = 0; i < end; i++) { out += ((String)
     * dataB2.get(i)).length() + 1; }
     */
    //Tester
    //        System.out.println("This is out:" + out);
    //        ByteBuffer test = toByteBuffer();
    //        System.out.println("The length" + test.array().length);
    //        System.out.println("END is:" + (char) test.array()[out++] + ""
    //                + (char) test.array()[out++] + "" + (char) test.array()[out++] + ""
    //                + (char) test.array()[out++] + "" + (char) test.array()[out++]);
    return out;
  }
  
  /**
   * @param object
   *  
   */
  public void put(String object) {
    if (object != null) {
      //System.out.println(object);
      lazyInit();
      if (!(dataBase.containsKey(object))) {
        //StringT pos = new StringT(dataBase.size(),getNewOffset());
        Integer pos = new Integer(dataBase.size());
        dataBase.put(object, pos);
        dataB2.add(pos.intValue(), object);
        offsets.add(pos.intValue(), getOffset(pos));
      }
    }
  }
  
  /**
   * @return
   */
  private Integer getOffset(Integer pos) {
    int out = 0;
    int thePos = pos.intValue();
    if (thePos != 0) {
      thePos = thePos - 1; //didn't want to make thePos-- 
      out = ((Integer) offsets.get(thePos)).intValue();
      out += ((String) dataB2.get(thePos)).length() + 1;
    }
    return new Integer(out);
  }
  
  /**
   *  
   */
  private void lazyInit() {
    if (dataB2 == null) dataB2 = new Vector();
    if (dataBase == null) dataBase = new Hashtable();
    if (offsets == null) offsets = new Vector();
    
  }
  
  /**
   * @param theAr
   */
  public void put(String[] theAr) {
    for (int i = 0; i < theAr.length; i++)
      put(theAr[i]);
  }
  
  /**
   * @param data
   * @param meta
   */
  public void take(ArcAudioFileDecorator data) {
    //TODO 2.0 Unittest what happens when AudioFile has Empty MetaData
    MetaData meta = data.getMetaData();
    if (meta != null) {
      this.put(data.getFileName());
      this.put(meta.getArtist());
      this.put(meta.getAlbum());
      this.put(meta.getTitle());
      this.put(meta.getGenre());
    }
  }
  
}