/*
 * $Id: ListAsRoot.java,v 1.2 2005/03/02 08:10:03 gruni Exp $
 * $Author: gruni $ 
 * $Revision: 1.2 $
 * $Date: 2005/03/02 08:10:03 $
 * $Log: ListAsRoot.java,v $
 * Revision 1.2  2005/03/02 08:10:03  gruni
 * structural refactoring made some stuff just better no new functions
 *
 * Revision 1.1  2005/02/27 01:42:36  gruni
 * The New Structure of Lists
 *
 */
package org.jd3lib.archoslib.lists;

import java.util.AbstractList;
import java.util.Iterator;
import java.util.Vector;

import org.jd3lib.archoslib.ArcAudioFileDecorator;
import org.jd3lib.archoslib.Strings;
import org.jd3lib.compatible.Queue;

/**
 * @author Andreas Grunewald
 * 
 * TODO v0.7 Document
 */
public class ListAsRoot
        extends List {

    private AbstractList ConfiguredLists;

    private Strings theStringResolver;

    /**
     * @param name
     */
    public ListAsRoot(String defName, Strings str) {
        super(defName, LIST_ROOT, null);
        setNumber((short) 0);
        theStringResolver = str;
        ConfiguredLists = getEntries();
    }

    public int resolveString(String resolvingString) {
        return theStringResolver.get(resolvingString);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.jd3lib.archoslib.lists.List#accept(java.lang.Object)
     */
    protected boolean accept(ArcEntry e) {
        if (e instanceof List && ((List) e).getParent() == this) return true;
        return false;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.jd3lib.archoslib.lists.List#process(org.jd3lib.archoslib.ArcAudioFileDecorator)
     */
    public void process(ArcAudioFileDecorator data) {
        Iterator confIterator = ConfiguredLists.iterator();
        while (confIterator.hasNext()) {
            ((org.jd3lib.archoslib.lists.List) confIterator.next())
                    .process(data);
        }
    }

    /**
     * Returns a Vector of All lists including sublists.
     * 
     * @return
     */
    public Vector getVectorOfAllLists() {
        Vector out = new Vector();
        Queue pq = new Queue();
        short count = this.getNumber();
        pq.add(this);
        List current;
        while (!(pq.isEmpty())) {
            current = (List) pq.remove();
            current.setNumber(count++);
            current.setResolver(theStringResolver);
            out.add(current);
            if (!(current instanceof ListOfSong))
                    pq.addAll(current.getEntries());
        }
        return out;
    }

    /**
     * Is used to add lists to the root Node.
     * 
     * @param artists
     *            TODO v2.0 make sure a list can not be added twice. There can
     *            be only one list of a specific name.
     */
    public void configure(List inputList) {
        this.add(inputList);
    }

    /**
     * This is a special case of getParentNumber because root must have -1 as
     * parent
     * 
     * @return -1 because Root never has a parent
     */
    protected short getParentNumber() {
        return -1;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.jd3lib.archoslib.lists.List#sort(boolean)
     */
    public void sort(boolean b) {
        //super.sort(b);
        Iterator confIterator = ConfiguredLists.iterator();
        while (confIterator.hasNext()) {
            ((org.jd3lib.archoslib.lists.List) confIterator.next()).sort(b);
        }
    }
}